
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>xtrabackup 用法【备忘】 / iVAN</title>

    <meta name="description" content="xtrabackup 用法【备忘】 优点 快速进行完整,可靠的备份 在备份过程中不中断进行中的事务 节省备份空间及网络带宽 支持自动备份机制,备份后自动完成校验 快速恢复 支持Percona Server, MySQL MariaDB, Drizzle 版本的热备份,流备份,压缩备份及增量备份机制 支持InnoDB, XtraDB, HailDB 存储引擎的无堵塞(在线)备份机制 对于 MyISAM, Merge Archive, 分区表,触发器,备份过程中需对引擎执行只读锁定 可在两个服务器之间在线迁移表 支持压缩的流备份到另外">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">xtrabackup 用法【备忘】</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>优点</p>
<p>快速进行完整，可靠的备份<br />
在备份过程中不中断进行中的事务<br />
节省备份空间及网络带宽<br />
支持自动备份机制，备份后自动完成校验<br />
快速恢复<br />
支持Percona Server, MySQL MariaDB, Drizzle 版本的热备份，流备份，压缩备份及增量备份机制<br />
支持InnoDB, XtraDB, HailDB 存储引擎的无堵塞（在线）备份机制<br />
对于 MyISAM, Merge Archive, 分区表，触发器，备份过程中需对引擎执行只读锁定<br />
可在两个服务器之间在线迁移表<br />
支持压缩的流备份到另外一台服务器上<br />
轻松建立 MySQL AB 复制</p>
<p> </p>
<p>下载地址<br /><a href="http://www.percona.com/software/percona-xtrabackup" rel="external nofollow noreferrer">http://www.percona.com/software/percona-xtrabackup</a></p>
<p> </p>
<p>编译方法</p>
<p>tar xf percona-xtrabackup-2.1.6.tar.gz<br />
cd  percona-xtrabackup-2.1.6</p>
<p>参考<br />
  ================== =========  =============================================<br />
  Value              Alias      Server<br />
  ================== =========  =============================================<br />
  innodb51           plugin build against InnoDB plugin in MySQL 5.1<br />
  innodb55           5.5  build against InnoDB in MySQL 5.5<br />
  xtradb51           xtradb     build against Percona Server with XtraDB 5.1<br />
  xtradb55           xtradb55   build against Percona Server with XtraDB 5.5<br />
  innodb56           5.6        build against InnoDB in MySQL 5.6<br />
  ================== =========  =============================================</p>
<p>根据你当前的数据库版本进行编译，如，当前使用 innodb 5.5 版本， 则编译如下</p>
<p> AUTO_DOWNLOAD="yes" ./utils/build.sh innodb55</p>
<p> </p>
<p>获得当前数据库版本方法<br />
如, xtradb55 返回结果如下</p>
<pre>select PLUGIN_DESCRIPTION, PLUGIN_VERSION from information_schema.plugins where plugin_name = 'Innodb';
+----------------------------------------------------------------------------+----------------+
| PLUGIN_DESCRIPTION                                                         | PLUGIN_VERSION |
+----------------------------------------------------------------------------+----------------+
| Percona-XtraDB, Supports transactions, row-level locking, and foreign keys | 5.5            |
+----------------------------------------------------------------------------+----------------+
1 row in set (0.00 sec)</pre>
<p> </p>
<p>如innodb55 返回结果如下</p>
<pre>select PLUGIN_DESCRIPTION, PLUGIN_VERSION from information_schema.plugins where plugin_name = 'Innodb';
+------------------------------------------------------------+----------------+
| PLUGIN_DESCRIPTION                                         | PLUGIN_VERSION |
+------------------------------------------------------------+----------------+
| Supports transactions, row-level locking, and foreign keys | 5.5            |
+------------------------------------------------------------+----------------+
1 row in set (0.00 sec)</pre>
<p> </p>
<p>当前编译版本</p>
<pre>AUTO_DOWNLOAD="yes" ./utils/build.sh xtradb55</pre>
<p> </p>
<p>编译成功，会生成  innobackupex 及 xtrabackup_55 二进制文件， 复制文件至 /usr/local/bin 下</p>
<pre>[root@db2 percona-xtrabackup-2.1.6]# cp innobackupex /usr/local/bin/.
[root@db2 percona-xtrabackup-2.1.6]# cp src/xtrabackup_55  /usr/local/bin/.</pre>
<p> </p>
<p>注: innobackup 文件是 perl 脚本，可看做是调用 xtrabackup 的工具<br />
    xtrabackup 是又 C 编译出来的二进制文件</p>
<p> </p>
<p>常见编译错误</p>
<pre>/usr/bin/ld: cannot find -laio
collect2: ld 返回 1
gmake: *** [xbstream] 错误 1
gmake: *** 正在等待未完成的任务....
xtrabackup.cc: In function ‘my_bool x</pre>
<p> </p>
<p>解决方法</p>
<pre>yum install -y  libaio libaio-devel </pre>
<p> </p>
<p>权限</p>
<p>备份过程中系统用户需要对存放备份数据的系统文件目录具备读写执行权限</p>
<p>而对数据库进行备份时候，建议具备下面的权限能力<br />
RELOAD, LOCK TABLES (除非指定 --no-lock 参数) 以便具备 flush tables with read lock 能力<br />
REPLICATION CLIENT 具备获得二进制日志文件备份能力<br />
CREATE TABLESPACE 具备恢复整个表空间，并导入表的能力<br />
SUPER 用于启动/关闭从服务器复制线程环境</p>
<p> </p>
<p>全库完整备份方法</p>
<pre>innobackupex --user=DBUSER --password=DBUSERPASS /path/to/BACKUP-DIR/
innobackupex --user=root --password=123 --socket=/var/run/mysqld/mysql5.socket /backup</pre>
<p>备份过程中可以看到 innobackupex 调用了 xtrabackup 工具</p>
<pre>131223 14:09:34  innobackupex: Starting ibbackup with command: xtrabackup_55  --defaults-group="mysqld" --backup --suspend-at-end --target-dir=/backup/2013-12-23_14-09-34 --tmpdir=/tmp
innobackupex: Waiting for ibbackup (pid=13829) to suspend
innobackupex: Suspend file '/backup/2013-12-23_14-09-34/xtrabackup_suspended_2'</pre>
<p>备份过程中终止日志线程，并以上一次 checkpoint 作为日志备份时间点</p>
<pre>xtrabackup: The latest check point (for incremental): '85727497'
xtrabackup: Stopping log copying thread.
.&gt;&gt; log scanned up to (85727497)</pre>
<p>完成所有备份后，可以看到下面信息返回</p>
<pre>innobackupex: Backup created in directory '/backup/2013-12-23_14-09-34'
131223 14:09:39  innobackupex: Connection to database server closed
131223 14:09:39  innobackupex: completed OK!</pre>
<p>上述全库备份方法将会自动把备份信息存放到一个以当前年-月-日_时-分-秒的目录中<br />
如果你希望自定义备份目录(注，目录需在备份过程中自动生成)，可以增加 --no-timestamp 参数，如</p>
<pre>innobackupex --user=root --password=123 --socket=/var/run/mysqld/mysql5.socket /backup/2013_12_23 --no-timestamp</pre>
<p>则备份时候会自动创建 2013_12_23 目录并把备份集存放至该目录中</p>
<p>注意，当前全库备份只备份至上文提到 checkpoint '85727497' 序号的事务及已经完成同步至磁盘中的数据，而已经执行，但还没有提交的事务仍然存放在内存中(innodb buffer)，导致当前数据文件处于非一致性状态<br />
假设当前要对全备进行恢复，则我们却要利用回滚未提交的事务，使得数据文件处于一致状态，因此，我们再执行完整全备之后，切记要执行一次  --apply-log 操作，这点是十分重要的</p>
<p>当前参考文件 /backup/2013-12-23_14-09-34/xtrabackup_checkpoints</p>
<pre>cat /backup/2013-12-23_14-09-34/xtrabackup_checkpoints
backup_type = full-backuped
from_lsn = 0
to_lsn = 85727497
last_lsn = 85727497
compact = 0</pre>
<p>执行 --apply-log 时，必须要指定之前的备份目录(因为需要获得正确的 xtrabackup_checkpoints 文件)</p>
<pre>cd /backup/2013-12-23_14-09-34
innobackupex --apply-log --defaults-file=/usr/local/mysql/etc/my.cnf --user=root --password=123 --socket=/var/run/mysqld/mysql5.socket  ./

xtrabackup: starting shutdown with innodb_fast_shutdown = 1
131223 16:23:40  InnoDB: Starting shutdown...
131223 16:23:44  InnoDB: Shutdown completed; log sequence number 85728268
131223 16:23:44  innobackupex: completed OK!</pre>
<p>参见最新后的 xtrabackup_checkpoints 文件信息</p>
<pre>backup_type = full-prepared
from_lsn = 0
to_lsn = 85727826
last_lsn = 85727826
compact = 0</pre>
<p>默认情况下，--apply-log 参数，只调用系统 100M 内存，如果当前 innodb buffer pool 比较大，则同步内存中数据时间可能会比较长，可以通过定义内存大小加快备份速度， 如参数 --use-memory=4G</p>
<p> </p>
<p> </p>
<p>恢复方法</p>
<p>要进行全库恢复，可调用参数  --copy-back</p>
<p>注: 当前全库恢复为离线恢复模式<br />
   需保证  datadir (/mdb) 数据库目录当前为空<br />
   需保证数据库处于关闭状态 <br />
  数据恢复后，需对 datadir (/mdb) 目录重新修改文件所有者为 mysql 用户</p>
<pre>innobackupex --copy-back --user=root --password=123 --socket=/var/run/mysqld/mysql5.socket /backup/2013-12-23_16-22-34

innobackupex: Starting to copy InnoDB log files
innobackupex: in '/backup/2013-12-23_16-22-34'
innobackupex: back to original InnoDB log directory '/mdb'
innobackupex: Copying '/backup/2013-12-23_16-22-34/ib_logfile1' to '/mdb/ib_logfile1'
innobackupex: Copying '/backup/2013-12-23_16-22-34/ib_logfile0' to '/mdb/ib_logfile0'
innobackupex: Finished copying back files.

131223 16:39:06  innobackupex: completed OK!</pre>
<p>备份完成后需要对数据库文件目录授权 mysql 用户属性</p>
<pre>[root@db2 /]# chown mysql:mysql /mdb -R</pre>
<p> </p>
<p>增量备份</p>
<p>注: 增量备份只支持 innodb 引擎， MyISAM 引擎无法实现增量，只会进行全表备份</p>
<pre>innobackupex --incremental /data/backups --incremental-basedir=BASEDIR</pre>
<p>备份恢复过程，先参考之前文档，执行一次全备份。（增量备份需建立在全备份之上）</p>
<p>全备</p>
<pre>innobackupex --user=root --password=123 --socket=/var/run/mysqld/mysql5.socket  /backup </pre>
<p>apply-log 备份</p>
<pre>innobackupex --user=root --password=123 --apply-log --socket=/var/run/mysqld/mysql5.socket  /backup/2013-12-24_14-58-26/</pre>
<p>检查当前 check-point 位置</p>
<pre>cat 2013-12-24_14-58-26/xtrabackup_checkpoints
backup_type = full-prepared
from_lsn = 0
to_lsn = 85760880
last_lsn = 85760880
compact = 0</pre>
<p>检查当前数据库的 lsn</p>
<pre>---
LOG
---
Log sequence number 85760880
Log flushed up to   85760880
Last checkpoint at  85760880
Max checkpoint age    7782360
Checkpoint age target 7539162</pre>
<p>为数据库插入数据.. （略)</p>
<p>增加数据后的  lsn</p>
<pre>---
LOG
---
Log sequence number 85764524
Log flushed up to   85764524
Last checkpoint at  85764524
Max checkpoint age    7782360
Checkpoint age target 7539162</pre>
<p> </p>
<p>执行增量备份</p>
<pre>innobackupex --user=root --password=123 --socket=/var/run/mysqld/mysql5.socket --incremental /backup --incremental-basedir=/backup/2013-12-24_14-58-26/</pre>
<p>--incremental-basedir 需要指定之前完整备份的目录<br />
--incremental  将会在改目录下生成新的目录用于存放增量备份数据</p>
<p>执行成功后， /backup 将会出现两个目录 <br />
2013-12-24_14-58-26 (完整备份)  2013-12-24_15-02-57 (增量备份)</p>
<p>查看当前增量备份 check-point 信息</p>
<pre>cat /backup/2013-12-24_15-02-57/xtrabackup_checkpoints
backup_type = incremental
from_lsn = 85760880
to_lsn = 85764524
last_lsn = 85764524
compact = 0</pre>
<p>完整备份 lsn 从 0 ~ 85760880， 增量备份 lsn 从 85760880 ~ 85764524 匹配当前数据库中的最后一次 lsn</p>
<p>分别按顺序(先全备再增量)对备份目录执行 --apply-log --redo-only 操作确保数据一致性(该操作只需要在恢复前执行)</p>
<pre>innobackupex --user=root --password=123 --socket=/var/run/mysqld/mysql5.socket --apply-log --redo-only /backup/2013-12-24_14-58-26

innobackupex --user=root --password=123 --socket=/var/run/mysqld/mysql5.socket --apply-log --redo-only /backup/2013-12-24_14-58-26 --incremental-dir=/backup/2013-12-24_15-02-57
</pre>
<p> </p>
<p>执行后再重新检验一次 check-point 文件, 发现全库备份的 checkpoint 已经包含了增量备份中的 lsn</p>
<pre>[root@db4 backup]# cat 2013-12-24_14-58-26/xtrabackup_checkpoints
backup_type = full-prepared
from_lsn = 0
to_lsn = 85764524
last_lsn = 85764524
compact = 0
[root@db4 backup]# cat 2013-12-24_15-02-57/xtrabackup_checkpoints
backup_type = incremental
from_lsn = 85760880
to_lsn = 85764524
last_lsn = 85764524
compact = 0</pre>
<p> </p>
<p>恢复方法跟之前一样, 只需要指定全库备份位置则可</p>
<pre>innobackupex --copy-back /backup/2013-12-24_14-58-26 </pre>
<p>时间点备份</p>
<p>全备恢复后，利用二进制日志进行时间点恢复，与 xtrabackup 无关， 纯 MYSQL 特点， 不详细讨论</p>
<p> </p>
<p>备份压缩</p>
<p>利用 --compress 参数实现</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:16:42</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/mysql/" title="mysql">mysql</a>, <a href="https://www.iamivan.net/tag/socket/" title="socket">socket</a>, <a href="https://www.iamivan.net/tag/innodb/" title="innodb">innodb</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>xtrabackup 用法【备忘】的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baB6k2M.html" rel="bookmark">mysql toolkit 用法&lbrack;备忘&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql toolkit 是一个小插件,用于对数据库进行监控,分析的小工具, 通常都是调用 perl  对当前的环境,数据库进行分析,比对,值得学习一下.   下载地址http://www.percona.com/redir/downloads/percona-toolkit/LATEST/RPM/percona-toolkit-2.2.5-2.noarch.rpm   安装时可能需要补充下面软件 yum install -y perl-DBD-mysql perl-IO-Socket-SSL			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7wvXXz.html" rel="bookmark">mysql中子查询limit用法备忘</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				select owner,count(*) as count from table1 where owner in (select xx.owner from (select owner from table1 where DATE_SUB(CURDATE(), INTERVAL 1 DAY) &lt;= date(date) and range&gt;=&quot;75&quot; group by owner order by count(*) desc limit 20) as xx) group			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvmKLab.html" rel="bookmark">技术备忘3</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   shell单引号与变量 [root@test] a=55 [root@test] echo $a 55 [root@test] echo '$a' $a [root@test] echo ''$a'' #注意此处是两个单引不是一个双引 55 总结: 在单引号中引用变量,需要这样来写(单引号括起来双引号内的变量.) :   '&quot;${a}&quot;' 原文地址 date星期求取 &lt;span style=&quot;font-family:Microsoft YaHei&quot;&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rk6Az.html" rel="bookmark">java备忘</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				swing 备忘 1.JfileChooser用法 JFileChooser file=new JFileChooser(); file.setAcceptAllFileFilterUsed(false); //关闭所有文件筛选器 file.setMultiSelectionEnabled(false); //关闭多选 file.setFileFilter(new FileNameExtensionFilter(&quot;TXT&quot;, &quot;txt&quot;)); //添加txt筛选器			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPBelvb.html" rel="bookmark">jQuery学习笔记--JqGrid相关操作 方法列表 备忘 重点讲解&lpar;超重要&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JqGrid相关操作备忘 方法列表 1.获得当前列表行数:$(&quot;#gridid&quot;).getGridParam(&quot;reccount&quot;); 2.获取选中行数据(json):$(&quot;#gridid&quot;).jqGrid('getRowData', id); 3.刷新列表:$(refreshSelector).jqGrid('setGridParam', { url: ''), postData: ''}).trigger('reloadGrid'); 4.选			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlmdaVp.html" rel="bookmark">JS操作COOKIE实现备忘记录的方法&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了JS操作COOKIE实现备忘记录的方法.分享给大家供大家参考,具体如下: 具体涉及JS针对cookie的写入与获取操作,代码如下: function getCookie(c_name) { if (document.cookie.length &gt; 0) { c_start = document.cookie.indexOf(c_name + &quot;=&quot;); if (c_start!=-1) { c_start = c_start + c_name.length + 1;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Vzwlomb.html" rel="bookmark">在Eclipse中构建备忘单</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Eclipse提供了一种用于显示迷你型指南的内置机制,称为备忘单(cheat sheet).备忘单可以快速而有效地指导您如何在Eclipse中执行包含多个步骤的过程,它显示在工作台的边角处,您可以容易且快速地查看它们. 本教程演示了如何为Eclipse构造备忘单.构造完毕之后,它们还可以运行在BEA Workshop Studio.BEA Workshop for WebLogic和其他任何Eclipse系统之上,或许能对您现有的工具和插件进行补充.示例下载中提供了3个准备好的备忘单,其中一个备			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlRB4qz.html" rel="bookmark">Oracle数据库如何手动恢复备忘日志</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近因为升级了Mac os x 10.10 Yosemite,突然前几天的一个晚上,开机发现就停留在开机界面了,看来BETA果然是不靠谱,然后想到自己这不前几天刚备份完吗,没事,TimeMachine是何等神器,二话不说直接恢复.但是恢复完,我后悔了,一来是忘了昨天晚上还加班呢,加班的成功保留成果所剩无几,关键我这才发现TimeMachine既然不备份虚拟机文件(虚拟机文件30G,估计直接给略过了吧),难怪每次都觉得备份那么快. 不过后悔也没用,重新搭开发环境吧.操作系统WIN7-&gt;开发工具VS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo607Xz.html" rel="bookmark">JDBC事务编程模型备忘</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Spring一统天下的情况下,JDBC快没有生存余地了.不过JDBC还是Java操作数据库的基础,现在Java项目中JDBC的应用快绝迹了,有必要对JDBC的事务编程模型做个象征性的总结. 下面是示例,保证代码可以编译,但不保证能运行,呵呵. import java.sql.*; /** * JDBC编程事务控制模型备忘 * * @author : leizhimin,2008-8-21 14:48:42.&lt;p&gt; */ public class JdbcTxText { public sta			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwLRavb.html" rel="bookmark">服务器迁移之debian重新配置Web服务的一些细节备忘</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这次服务系统采用的是最新的Debian 7.0,但是有几个细节的忽略导致我折腾了一番,我再这里再做个记录吧   之前配置Linux服务器时采用的是Debian系统一直很稳定,这次准备迁移到新的服务器环境上,好在以前的配置我在博客都做了备忘,所以很容易就搞定了,这次服务系统采用的是最新的Debian 7.0,但是有几个细节的忽略导致我折腾了一番,我再这里再做个记录吧: 首先要安装编译环境,虽然我们通过apt-get可以方便的绕过手动编译的环节,但是一些程序包可能内置编译命令,可以编译一些扩展程序,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqA2ZM.html" rel="bookmark" class="title">电力行业数据建模工具选型实施案例分享</a>
					<div>
						由于需要记录日益复杂的数据仓库实现,导致美国Omaha公用电力分部的IT工 作人员不得不购买一套新的图形化的数据建模工具,但要获得母公司对该项目的 审批,几乎是不可能的. 公用事业部门负责向内布拉斯加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLggZM.html" rel="bookmark" class="title">net framework-为何称简单的int数和泛型列表为不稳定资源，不稳定资源是如何定义的？</a>
					<div>
						问题描述 为何称简单的int数和泛型列表为不稳定资源,不稳定资源是如何定义的? 在&lt;C#高级编程&gt;的System.Transaction章节中称简单的int数和泛型列表为不稳定资源(原文: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5vl7z.html" rel="bookmark" class="title">翻译&rsqb;&period;NET委托：一个C&num;睡前故事</a>
					<div>
						翻译].NET委托:一个C#睡前故事 英文原版地址:英文原版地址:http://www.sellsbrothers.com/writin...t=delegates.htm   .NET委托:一个C# ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpdg2XM.html" rel="bookmark" class="title">百度快照不更新内容不收录的五点经验分享【原创】</a>
					<div>
						从2010年12月份开始发布了自己的网站&quot;遮天吧&quot;,也和很多站长一样,经历了被百度的折磨,网站不被收录,快照突然停止,蜘蛛爬行很少等等情况让站长的心情大起大落,说实在的百度的确很抽 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP7YZM.html" rel="bookmark" class="title">三点让你快速提升内页权重 让内页排名飞起来</a>
					<div>
						网站是由不同的页面组成的,有首页和内页之分,不同的页面又因为内链传递的权重和内容关系又有着不同的权重之分.但往往是首页的权重是最大的,所以内页要有好的权重,是离不开首页的支持.今天我们来来说说如何让内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeJ4Ab.html" rel="bookmark" class="title">细节决定成败 内链建设不能忽视的细节</a>
					<div>
						  随着搜索引擎的越来越人性化,搜索引擎对于站点的内部结构的要求也越来越高.对此,现今如果你想要你的关键词有一个好的稳定的排名,你不仅仅需要一个强大的外链做支持,你还需要有一个合理的站内内部结构做坚实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5A2Lqp.html" rel="bookmark" class="title">symbian入门系列&colon; document对象分析</a>
					<div>
						Document分析「继承关系」 --------------------------CAknDocument -&gt; CEikDocument -&gt; CApaDocument------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7AAab.html" rel="bookmark" class="title">css的em&sol;ex&sol;px&sol;pt&lpar;css长度单位&rpar;使用介绍</a>
					<div>
						  em:1em为当前字体font-size,一般浏览器默认为(16px); ex:以给定字体的小写字母x的高度为基准 px:像素,屏幕上的一个小方格 pt单位名称为点(Point),绝对长度单位一般 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwRn8p.html" rel="bookmark" class="title">360删除的文件怎么恢复？</a>
					<div>
						  对于一些正常的文件,360有时也会报毒,导致正常文件被删除,有些文件我们可以通过360隔离区进行恢复,但是一些文件特别是软件这类的,可能已经被破坏了,导致恢复不了,针对这种清理下的文件恢复问题!  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9ELEVM.html" rel="bookmark" class="title">在XP系统中远程桌面连接不上的解决方式</a>
					<div>
						  连接远程桌面在现在看来已经是十分必要的了,有些人常常出外上班或者出差,但是需要用到原本的电脑的时候就可以用这样的方法实现.用Window Server20008远程桌面连接一台windows xp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3o30gb.html" rel="bookmark" class="title">&lbrack;收藏学习&rsqb;Linux的实时监测命令</a>
					<div>
						十八.  和系统运行状况相关的Shell命令:     1. Linux的实时监测命令(watch):     watch 是一个非常实用的命令,可以帮你实时监测一个命令的运行结果,省得一遍又一遍的手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlm4mb.html" rel="bookmark" class="title">api-C&num;窗体应用程序调用百度地图</a>
					<div>
						问题描述 C#窗体应用程序调用百度地图 如题,不知道怎么调用,求详细一点,谢谢各位大侠.万分感激.... 解决方案 C#窗体应用程序C#窗体应用程序中,调用已有应用程序(*.exe) 解决方案二: 调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrQNGM.html" rel="bookmark" class="title">Git环境搭建与基本使用方法 （转自http&colon;&sol;&sol;blog&period;csdn&period;net&sol;fireelement&sol;article&sol;details&sol;9618363）</a>
					<div>
						﻿﻿ 以前公司有的项目也用这个东东,但我的项目中还是始终使用svn,华为以前用的是VSS,不过后来也开始推别的了,如CVS(2006年,SVN貌似还不太火). Git这个东东不必说太多,想来大家也都听 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3GK5z.html" rel="bookmark" class="title">微软为啥让免费升Win10？</a>
					<div>
						      今天终于赶在截止日期之前把我的联想PC升到win10.微软这次对中国开放的持续一年的免费升级活动主要有两个原因.首先当然是&quot;感恩Windows用户长久支持的回馈&quot;.微软 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLm3oaz.html" rel="bookmark" class="title">柯里化的前生今世（二）：括号神教</a>
					<div>
						The limits of your languages are the limits of your world. 只会一种语言,会限制你的视野,很难有机会去接触那些有趣的想法. 语言是表达思想的工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlZZjp.html" rel="bookmark" class="title">MySQL学习第六天 学习MySQL基本数据类型&lowbar;Mysql</a>
					<div>
						还记得上一篇学习的内容吗?不记得再看一看MySQL学习第五天 MySQL数据库基本操作,温故可以知新!         数据类型是指列.存储过程参数.表达式和局部变量的数据特征,它决定了数据的存储方式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5e0xM.html" rel="bookmark" class="title">winform-C&num; Winform项目&comma;如何实现打开的外部视频客户端程序响应后台程序的键盘事件</a>
					<div>
						问题描述 C# Winform项目,如何实现打开的外部视频客户端程序响应后台程序的键盘事件 在C# Winform项目,在form1窗体有一个button按钮. 目前已经可以在button的点击事件中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRvW1b.html" rel="bookmark" class="title">oracle internal services阅读总结1</a>
					<div>
						1.oracle内核层级 oracle内核由多层组成,主要层级在图1.1中展示.每一层依赖于它下一层的服务,但有时候也会以任何顺序直接调用任何一层.然而,控制层从来不会向上传递堆栈,除了返回调用结果的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqXeyz.html" rel="bookmark" class="title">Linux svn 版本库的自动更新方法</a>
					<div>
						安装好svn以后,目录结构如下: 下面主要对hooks目录的内容进行修改: cd hooks vi post-commit  代码如下 复制代码 #!/bin/sh svn up –username= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK78Ob.html" rel="bookmark" class="title">Timeline 0&period;16&period;0发布 时间轴工具</a>
					<div>
						Timeline是一个免费的跨平台应用程序,用于显示和操作时间轴上的事件任务,支持GNU General Public License, version 3版本. Timeline 0.16.0该版本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRXDAp.html" rel="bookmark" class="title">谁有用c&num;开发过对接MT4交易软件API的程序</a>
					<div>
						问题描述 谁有用c#开发过对接MT4交易软件API的程序,能否一起交流交流,想请教请教 解决方案					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrqjvvb.html" rel="bookmark" class="title">求一本书关于c&num; Windows 窗体应用程序 Windows Forms</a>
					<div>
						问题描述 求一本书关于c# Windows 窗体应用程序 Windows Forms 求一本书关于c# Windows 窗体应用程序 Windows Forms类似于下面这本书 解决方案 直接WPF吧 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBky4AM.html" rel="bookmark" class="title">php的api数据接口书写实例&lpar;推荐&rpar;&lowbar;php实例</a>
					<div>
						以下是接口代码实例: &lt;?php $output = array(); $a = @$_GET['a'] ? $_GET['a'] : ''; $uid = @$_GET['uid'] ? $_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlXRqp.html" rel="bookmark" class="title">asp&period;net c&num;Treeview 增加节点</a>
					<div>
						asp教程.net c#treeview 增加节点 void  creat_node(string name,microsoft.web.ui.webcontrols.treenode  t1,str ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QrZap.html" rel="bookmark" class="title">asp&period;net生成缩略图实现代码&lowbar;实用技巧</a>
					<div>
						复制代码 代码如下: using System; using System.Collections.Generic; using System.Linq; using System.Web; usin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0naOz.html" rel="bookmark" class="title">如何走出沙盒与浅谈影响链接价值</a>
					<div>
						如何走出沙盒与浅谈影响链接价值 影响连接价值五个最重要因素如下: 1. /Robots.txt excluded page:用 /robots.txt 能够让搜索引擎无法读取网页.如果搜索引擎不知道该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkBdvp.html" rel="bookmark" class="title">CYQ&period;Data开源数据层框架使用例子</a>
					<div>
						一.准备工具 创建Sqlite数据库test.db,添加表Person:   Create TABLE Person (     Id   INTEGER PRIMARY KEY AUTOINCREM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NWZ9p.html" rel="bookmark" class="title">java-JAVA中求整数平均数的问题</a>
					<div>
						问题描述 JAVA中求整数平均数的问题 需要代替(a+b)/2的代码.(此代码有数据溢出的风险) 除了类型转换和分类讨论还有其他的方法吗? a和b都是int,且不分正负. 解决方案 a/2+b/2+( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkRkZz.html" rel="bookmark" class="title">think。php中怎么去掉重复的求大神解决</a>
					<div>
						问题描述 think.php中怎么去掉重复的求大神解决 $st_huawu=$st_huawu-&gt;where(&quot;&quot;rid&lt;=150&quot;&quot;)-&gt;s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6WAPM.html" rel="bookmark" class="title">请教大家《设计模式》中单例模式的疑问</a>
					<div>
						问题描述 书中介绍了几种只创建一个类实例的方法,其中第二种是:声明类为final,然后访问其中的静态方法而不用创建类的实例.但是这种方法是可以创建实例的,实在想不通这个方法跟单例模式有什么关系...请 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
